/*
 * This file is distributed according to the GNU Lesser Public Licence.
 * Created on 5 avr. 2005
 *
 */
package personneDandD;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 * Application de test du drag and drop java 1.4.
 * <p> remarque : j'ai un comportement bizarre en faisant un drop dans
 * firefox quand la jvm est java 1.4.2.6. Avec 1.5, c'est nikel.
 * @author Serge Rosmorduc
 */
public class PersonneAppli extends JFrame {

    /**
     * 
     * @uml.property name="jContentPane"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private javax.swing.JPanel jContentPane = null;


    /**
     * This is the default constructor
     */
    public PersonneAppli() {
        super();
        initialize();
    }

    /**
     * This method initializes this
     * 
     * @return void
     */
    private void initialize() {
        this.setContentPane(getJContentPane());
        pack();
        this.setTitle("JFrame");
    }

    /**
     * This method initializes jContentPane
     * 
     * @return javax.swing.JPanel
     * 
     * @uml.property name="jContentPane"
     */
    private javax.swing.JPanel getJContentPane() {
        if (jContentPane == null) {
            jContentPane = new JPanel();
            jContentPane
                .setLayout(new BoxLayout(jContentPane, BoxLayout.X_AXIS));
            PersonnePanel p1, p2;
            p1 = new PersonnePanel();

            // Autorisons p1  fonctionner comme source de Drag and Drop.
            p1.enableDrag();
            p2 = new PersonnePanel();
            // p2, quant  lui, est dpourvu de listener: il ne peut initier un drag
            // and drop. Par contre, il fonctionne trs bien comme destination de drag and drop.
            jContentPane.add(p1);
            jContentPane.add(p2);

        }
        return jContentPane;
    }

    
    public static void main(String[] args) {
        PersonneAppli app= new PersonneAppli();
        app.setVisible(true);
        app.addWindowListener(new WindowListener() {

            public void windowActivated(WindowEvent e) {
                // TODO Auto-generated method stub
                
            }

            public void windowClosed(WindowEvent e) {
                // TODO Auto-generated method stub
                
            }

            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }

            public void windowDeactivated(WindowEvent e) {
                // TODO Auto-generated method stub
                
            }

            public void windowDeiconified(WindowEvent e) {
                // TODO Auto-generated method stub
                
            }

            public void windowIconified(WindowEvent e) {
                // TODO Auto-generated method stub
                
            }

            public void windowOpened(WindowEvent e) {
                // TODO Auto-generated method stub
                
            }
            
        });
    }
}