package personneDandD;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/*
 * This file is distributed according to the GNU Lesser Public Licence.
 * Created on 5 avr. 2005
 *
 */

/**
 * Un objet graphique qui montre les informations sur une personne.
 * 
 * @author Serge Rosmorduc
 */
public class PersonnePanel extends JPanel {

    /**
     * 
     * @uml.property name="jLabel"
     * @uml.associationEnd multiplicity="(1 1)"
     */
    private JLabel jLabel = null;

    /**
     * 
     * @uml.property name="nomField"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private JTextField nomField = null;

    /**
     * 
     * @uml.property name="prenomField"
     * @uml.associationEnd multiplicity="(0 1)"
     */
    private JTextField prenomField = null;

    /**
     * 
     * @uml.property name="jLabel1"
     * @uml.associationEnd multiplicity="(1 1)"
     */
    private JLabel jLabel1 = null;


    /**
     * This is the default constructor
     */
    public PersonnePanel() {
        initialize();
        // Pour autoriser les champs jtextfields  faire du drag and drop,
        // dcommenter :
        //nomField.setDragEnabled(true);

        // On assigne un transfertHandler  cet objet. Le handler
        // sera en charge des oprations lies au drag and drop.
        setTransferHandler(new PersonneTransferHandler());
        // Attention !!
        // Ce que nous venons d'crire suffit pour que l'objet soit cible d'un
        // drag and drop.
        // Pour qu'il fonctionne comme source, il faut utiliser un listener
        // quelconque qui
        // appellera exportAsDrag. La mthode enableDrag installe un tel
        // listener.
        
        // Si vous dcommentez la ligne suivante, le champ
        // "nom" pourra lui aussi faire du drag and drop.
        //nomField.setDragEnabled(true);
        
    }

    public void enableDrag() {
        addMouseListener(new DragAndDropListener());
    }

    /**
     * Cration des objets graphiques et layout. (vraiment rien d'intressant 
     * lire ici).
     * 
     * @return void
     */
    private void initialize() {
        jLabel1 = new JLabel();
        GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
        jLabel = new JLabel();
        GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
        GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
        GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
        this.setLayout(new GridBagLayout());

        //this.setSize(302, 38);

        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jLabel.setText("nom");
        gridBagConstraints2.gridx = 1;
        gridBagConstraints2.gridy = 0;
        gridBagConstraints2.weightx = 1.0;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints3.gridx = 1;
        gridBagConstraints3.gridy = 1;
        gridBagConstraints3.weightx = 1.0;
        gridBagConstraints3.weighty = 1.0;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints11.gridx = 0;
        gridBagConstraints11.gridy = 1;
        gridBagConstraints11.anchor = java.awt.GridBagConstraints.NORTH;
        jLabel1.setText("prenom");
        this.add(jLabel, gridBagConstraints1);
        this.add(getNomField(), gridBagConstraints2);
        this.add(getPrenomField(), gridBagConstraints3);
        this.add(jLabel1, gridBagConstraints11);

    }

    /**
     * This method initializes jTextField
     * 
     * @return javax.swing.JTextField
     * 
     * @uml.property name="nomField"
     */
    private JTextField getNomField() {
        if (nomField == null) {
            nomField = new JTextField();
            nomField.setColumns(30);
        }
        return nomField;
    }

    /**
     * This method initializes prenomField
     * 
     * @return javax.swing.JScrollPane
     * 
     * @uml.property name="prenomField"
     */
    private JTextField getPrenomField() {
        if (prenomField == null) {
            prenomField = new JTextField();
            prenomField.setColumns(30);
        }
        return prenomField;
    }

    /**
     * Cre un objet "personne" correspondant aux donnes du formulaire.
     * 
     * @return
     */
    public Personne getPersonne() {
        Personne p = new Personne(nomField.getText(), prenomField.getText());
        return p;
    }

    /**
     * Fixe les donnes du formulaire pour correspondre  la personne "p".
     * 
     * @return
     */
    public void setPersonne(Personne p) {
        nomField.setText(p.getNom());
        prenomField.setText(p.getPrenom());
    }
} //  @jve:decl-index=0:visual-constraint="10,10"



